#[doc = "Register `ECO_STATUS` reader"]
pub struct R(crate::R<ECO_STATUS_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<ECO_STATUS_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<ECO_STATUS_SPEC>> for R {
    fn from(reader: crate::R<ECO_STATUS_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `ECO_STATUS` writer"]
pub struct W(crate::W<ECO_STATUS_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<ECO_STATUS_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<ECO_STATUS_SPEC>> for W {
    fn from(writer: crate::W<ECO_STATUS_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `WATCHDOG_ERROR` reader - This bit is set to 1 if the oscillator is stuck. The ECO clock is gated off during a watchdog error condition. Due to internal synchonization, the clock is stopped two cycles after an error condition is observed and ungated two cycles after the error condition is resolved."]
pub struct WATCHDOG_ERROR_R(crate::FieldReader<bool, bool>);
impl WATCHDOG_ERROR_R {
    pub(crate) fn new(bits: bool) -> Self {
        WATCHDOG_ERROR_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for WATCHDOG_ERROR_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl R {
    #[doc = "Bit 0 - This bit is set to 1 if the oscillator is stuck. The ECO clock is gated off during a watchdog error condition. Due to internal synchonization, the clock is stopped two cycles after an error condition is observed and ungated two cycles after the error condition is resolved."]
    #[inline(always)]
    pub fn watchdog_error(&self) -> WATCHDOG_ERROR_R {
        WATCHDOG_ERROR_R::new((self.bits & 0x01) != 0)
    }
}
impl W {
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "ECO Status Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [eco_status](index.html) module"]
pub struct ECO_STATUS_SPEC;
impl crate::RegisterSpec for ECO_STATUS_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [eco_status::R](R) reader structure"]
impl crate::Readable for ECO_STATUS_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [eco_status::W](W) writer structure"]
impl crate::Writable for ECO_STATUS_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets ECO_STATUS to value 0"]
impl crate::Resettable for ECO_STATUS_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
